Index: code/branches/pickupsFS14/src/modules/jump/JumpCenterpoint.h
===================================================================
--- code/branches/pickupsFS14/src/modules/jump/JumpCenterpoint.h	(revision 10050)
+++ code/branches/pickupsFS14/src/modules/jump/JumpCenterpoint.h	(revision 10050)
@@ -0,0 +1,245 @@
+/*
+ *   ORXONOX - the hottest 3D action shooter ever to exist
+ *                    > www.orxonox.net <
+ *
+ *
+ *   License notice:
+ *
+ *   This program is free software; you can redistribute it and/or
+ *   modify it under the terms of the GNU General Public License
+ *   as published by the Free Software Foundation; either version 2
+ *   of the License, or (at your option) any later version.
+ *
+ *   This program is distributed in the hope that it will be useful,
+ *   but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *   GNU General Public License for more details.
+ *
+ *   You should have received a copy of the GNU General Public License
+ *   along with this program; if not, write to the Free Software
+ *   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
+ *
+ *   Author:
+ *      Fabian 'x3n' Landau
+ *   Co-authors:
+ *      ...
+ *
+ */
+
+/**
+    @file JumpCenterpoint.h
+    @brief Declaration of the JumpCenterpoint class.
+    @ingroup Jump
+*/
+
+#ifndef _JumpCenterpoint_H__
+#define _JumpCenterpoint_H__
+
+#include "jump/JumpPrereqs.h"
+
+#include <string>
+
+#include <util/Math.h>
+
+#include "worldentities/StaticEntity.h"
+
+namespace orxonox
+{
+    
+    /**
+    @brief
+        The JumpCenterpoint implements the playing field @ref orxonox::Jump "Jump" takes place in and allows for many parameters of the minigame to be set.
+        The playing field resides in the x,z-plane, with the x-axis being the horizontal axis and the z-axis being the vertical axis.
+        
+        Various parameters can be set:
+        - The <b>dimension</b> is a vector, that defines the width and height of the playing field. The default is <em>(200, 120)</em>.
+        - The <b>balltemplate</b> is a template that is applied to the @ref orxonox::JumpPlatform "JumpPlatform", it can be used to attach different things to it, e.g. its @ref orxonox::Model "Model". See below for a usage example.
+        - The <b>battemplate</b> is a template that is applied to the @ref orxonox::JumpPlatform "JumpFigure", it can be used to attach different things to it, e.g. its @ref orxonox::Model "Model". See below for a usage example.
+        - The <b>ballspeed</b> is the speed with which the @ref orxonox::JumpPlatform "JumpPlatform" moves. The default is <em>100</em>.
+        - The <b>ballaccfactor</b> is the acceleration factor for the @ref orxonox::JumpPlatform "JumpPlatform". The default is <em>1.0</em>.
+        - The <b>batspeed</b> is the speed with which the @ref orxonox::JumpFigure "JumpFigures" move. The default is <em>60</em>.
+        - The <b>batlength</b> is the length of the @ref orxonox::JumpFigure "JumpFigures" as the percentage of the height of the playing field. The default is <em>0.25</em>.
+        
+        An example in XML of the JumpCenterpoint would be:
+        
+        First the needed templates:
+        The template for the @ref orxonox::JumpPlatform "JumpPlatform".
+        @code
+        <Template name="jumpball">
+          <JumpPlatform>
+            <attached>
+              <Model mesh="sphere.mesh" scale="2" />
+              <ParticleSpawner name="hiteffect" position="0,0,0" source="Orxonox/sparks2" lifetime="0.01" autostart="0" mainstate="spawn" />
+            </attached>
+            <eventlisteners>
+              <EventTarget target="hiteffect" />
+            </eventlisteners>
+          </JumpPlatform>
+        </Template>
+        @endcode
+        As can be seen, a sphere is attached as the @ref orxonox::Model "Model" for the @ref orxonox::JumpPlatform "JumpPlatform", and also an @ref orxonox::EventListener "EventListener" that triggers a @ref orxonox::ParticleSpawner "ParticleSpawner", whenever the ball hits the boundaries is attached.
+        
+        Additionally the template for the @ref orxonox::JumpFigure "JumpFigure".
+        @code
+        <Template name="jumpbatcameras" defaults="0">
+          <JumpFigure>
+            <camerapositions>
+              <CameraPosition position="0,200,0" pitch="-90" absolute="true" />
+            </camerapositions>
+          </JumpFigure>
+        </Template>
+
+        <Template name="jumpbat">
+          <JumpFigure camerapositiontemplate=jumpbatcameras>
+            <attached>
+              <Model position="0,0,3" mesh="cube.mesh" scale3D="14,2,2" />
+            </attached>
+          </JumpFigure>
+        </Template>
+        @endcode
+        As can be seen, there are actually two templates. The first template is needed to set the camera for the @ref orxonox::JumpFigure "JumpFigure". The second template ist the actual template for the @ref orxonox::JumpFigure "JumpFigure", the template for the camera position is added and a @ref orxonox::Model "Model" for the @ref orxonox::JumpFigure "JumpFigure" is attached.
+        
+        Finally the JumpCenterpoint is created.
+        @code
+        <JumpCenterpoint name="jumpcenter" dimension="200,120" balltemplate="jumpball" battemplate="jumpbat" ballspeed="200" ballaccfactor="1.0" batspeed="130" batlength="0.25">
+          <attached>
+            <Model position="0,0,60" mesh="cube.mesh" scale3D="105,1,1" />
+            <Model position="0,0,-60" mesh="cube.mesh" scale3D="105,1,1" />
+          </attached>
+        </JumpCenterpoint>
+        @endcode
+        All parameters are specified. And also two @ref orxonox::Model "Models" (for the upper and lower boundary) are attached.
+        
+        For a more elaborate example, have a look at the <code>jump.oxw</code> level file.
+    
+    @author
+        Fabian 'x3n' Landau
+        
+    @ingroup Jump
+    */
+    class _JumpExport JumpCenterpoint : public StaticEntity
+    {
+        public:
+            JumpCenterpoint(Context* context); //!< Constructor. Registers and initializes the object and checks whether the gametype is actually Jump.
+            virtual ~JumpCenterpoint() {}
+
+            virtual void XMLPort(Element& xmlelement, XMLPort::Mode mode); //!< Method to create a JumpCenterpoint through XML.
+
+            virtual void changedGametype(); //!< Is called when the gametype has changed.
+
+
+            void setPlatformStaticTemplate(const std::string& balltemplate)
+                { this->platformStaticTemplate_ = balltemplate; }
+
+            const std::string& getPlatformStaticTemplate() const
+                { return this->platformStaticTemplate_; }
+
+            void setPlatformHMoveTemplate(const std::string& balltemplate)
+                { this->platformHMoveTemplate_ = balltemplate; }
+
+            const std::string& getPlatformHMoveTemplate() const
+                { return this->platformHMoveTemplate_; }
+
+            void setPlatformVMoveTemplate(const std::string& balltemplate)
+                { this->platformVMoveTemplate_ = balltemplate; }
+
+            const std::string& getPlatformVMoveTemplate() const
+                { return this->platformVMoveTemplate_; }
+
+            void setPlatformDisappearTemplate(const std::string& balltemplate)
+                { this->platformDisappearTemplate_ = balltemplate; }
+
+            const std::string& getPlatformDisappearTemplate() const
+                { return this->platformDisappearTemplate_; }
+
+            void setPlatformTimerTemplate(const std::string& balltemplate)
+                { this->platformTimerTemplate_ = balltemplate; }
+
+            const std::string& getPlatformTimerTemplate() const
+                { return this->platformTimerTemplate_; }
+
+            void setPlatformFakeTemplate(const std::string& balltemplate)
+                { this->platformFakeTemplate_ = balltemplate; }
+
+            const std::string& getPlatformFakeTemplate() const
+                { return this->platformFakeTemplate_; }
+
+            void setProjectileTemplate(const std::string& newTemplate)
+                { this->projectileTemplate_ = newTemplate; }
+
+            const std::string& getProjectileTemplate() const
+                { return this->projectileTemplate_; }
+
+            void setFigureTemplate(const std::string& newTemplate)
+                { this->figureTemplate_ = newTemplate; }
+
+            const std::string& getFigureTemplate() const
+                { return this->figureTemplate_; }
+
+            void setEnemy1Template(const std::string& newTemplate)
+                { this->enemy1Template_ = newTemplate; }
+
+            const std::string& getEnemy1Template() const
+                { return this->enemy1Template_; }
+
+
+            /**
+            @brief Set the dimensions of the playing field.
+            @param dimension A vector with the width of the playing field as first component and the height as second.
+            */
+            void setFieldDimension(const Vector2& dimension)
+                { this->width_ = dimension.x; this->height_ = dimension.y; }
+            /**
+            @brief Get the dimensions of the playing field.
+            @return Returns a vector with the width of the playing field as first component and the height as second.
+            */
+            Vector2 getFieldDimension() const
+                { return Vector2(this->width_, this->height_); }
+
+            /**
+            @brief Set the dimensions of the playing field.
+            @param dimension A vector with the width of the playing field as first component and the height as second.
+            */
+            void setSectionLength(const float sectionLength)
+                { this->sectionLength_ = sectionLength; }
+            /**
+            @brief Get the dimensions of the playing field.
+            @return Returns a vector with the width of the playing field as first component and the height as second.
+            */
+            float getSectionLength() const
+                { return sectionLength_; }
+
+            /**
+            @brief Set the dimensions of the playing field.
+            @param dimension A vector with the width of the playing field as first component and the height as second.
+            */
+            void setPlatformLength(const float platformLength)
+                { this->platformLength_ = platformLength; }
+            /**
+            @brief Get the dimensions of the playing field.
+            @return Returns a vector with the width of the playing field as first component and the height as second.
+            */
+            float getPlatformLength() const
+                { return platformLength_; }
+
+        private:
+            void checkGametype(); //!< Checks whether the gametype is Jump and if it is, sets its centerpoint.
+
+            std::string platformStaticTemplate_; //!< The template for the ball.
+            std::string platformHMoveTemplate_; //!< The template for the ball.
+            std::string platformVMoveTemplate_; //!< The template for the ball.
+            std::string platformDisappearTemplate_; //!< The template for the ball.
+            std::string platformTimerTemplate_; //!< The template for the ball.
+            std::string platformFakeTemplate_; //!< The template for the ball.
+            std::string projectileTemplate_; //!< The template for the ball.
+            std::string figureTemplate_; //!< The template for the bats.
+            std::string enemy1Template_; //!< The template for the bats.
+
+            float width_; //!< The height of the playing field.
+            float height_; //!< The width of the playing field.
+            float sectionLength_; //!< Height of one section
+            float platformLength_; // Avoids intersecting platforms
+    };
+}
+
+#endif /* _JumpCenterpoint_H__ */
Index: code/branches/pickupsFS14/src/modules/jump/JumpEnemy.cc
===================================================================
--- code/branches/pickupsFS14/src/modules/jump/JumpEnemy.cc	(revision 10050)
+++ code/branches/pickupsFS14/src/modules/jump/JumpEnemy.cc	(revision 10050)
@@ -0,0 +1,145 @@
+/*
+ *   ORXONOX - the hottest 3D action shooter ever to exist
+ *                    > www.orxonox.net <
+ *
+ *
+ *   License notice:
+ *
+ *   This program is free software; you can redistribute it and/or
+ *   modify it under the terms of the GNU General Public License
+ *   as published by the Free Software Foundation; either version 2
+ *   of the License, or (at your option) any later version.
+ *
+ *   This program is distributed in the hope that it will be useful,
+ *   but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *   GNU General Public License for more details.
+ *
+ *   You should have received a copy of the GNU General Public License
+ *   along with this program; if not, write to the Free Software
+ *   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
+ *
+ *   Author:
+ *      Fabian 'x3n' Landau
+ *   Co-authors:
+ *      ...
+ *
+ */
+
+/**
+    @file JumpEnemy.cc
+    @brief Implementation of the JumpEnemy class.
+*/
+
+#include "JumpEnemy.h"
+
+#include "core/CoreIncludes.h"
+#include "core/GameMode.h"
+#include "graphics/Model.h"
+#include "gametypes/Gametype.h"
+
+#include "JumpFigure.h"
+
+#include "sound/WorldSound.h"
+#include "core/XMLPort.h"
+
+namespace orxonox
+{
+    RegisterClass(JumpEnemy);
+
+    /**
+    @brief
+        Constructor. Registers and initializes the object.
+    */
+    JumpEnemy::JumpEnemy(Context* context) : MovableEntity(context)
+    {
+        RegisterObject(JumpEnemy);
+
+        this->figure_ = 0;
+        setProperties(0.0, 0.0, 0.0, 0.0, 0.0, 0.0);
+        this->setPosition(Vector3(0,0,0));
+        this->setVelocity(Vector3(0,0,0));
+        this->setAcceleration(Vector3(0,0,0));
+    }
+
+    /**
+    @brief
+        Destructor.
+    */
+    JumpEnemy::~JumpEnemy()
+    {
+        /*if (this->isInitialized())
+        {
+            if (this->bDeleteBats_)
+                delete this->figure_;
+
+            delete[] this->batID_;
+        }*/
+    }
+
+    //xml port for loading sounds
+    void JumpEnemy::XMLPort(Element& xmlelement, XMLPort::Mode mode)
+    {
+        SUPER(JumpEnemy, XMLPort, xmlelement, mode);
+    }
+
+    /**
+    @brief
+        Is called every tick.
+        Handles the movement of the ball and its interaction with the boundaries and bats.
+    @param dt
+        The time since the last tick.
+    */
+    void JumpEnemy::tick(float dt)
+    {
+        SUPER(JumpEnemy, tick, dt);
+
+        // Get the current position, velocity and acceleration of the enemy.
+        Vector3 position = getPosition();
+        Vector3 velocity = getVelocity();
+
+        if ((position.x < leftBoundary_ && velocity.x < 0) || (position.x > rightBoundary_ && velocity.x > 0))
+        {
+        	velocity.x = -velocity.x;
+        }
+
+        if ((position.z < lowerBoundary_ && velocity.z < 0) || (position.z > upperBoundary_ && velocity.z > 0))
+        {
+        	velocity.z = -velocity.z;
+        }
+
+        // Set the position, velocity and acceleration of the enemy, if they have changed.
+        if (velocity != getVelocity())
+            setVelocity(velocity);
+        if (position != getPosition())
+            setPosition(position);
+
+
+    }
+
+    void JumpEnemy::setProperties(float newLeftBoundary, float newRightBoundary, float newLowerBoundary, float newUpperBoundary, float newHSpeed, float newVSpeed)
+    {
+        leftBoundary_ = newLeftBoundary;
+        rightBoundary_ = newRightBoundary;
+        lowerBoundary_ = newLowerBoundary;
+        upperBoundary_ = newUpperBoundary;
+
+        this->setVelocity(Vector3(newHSpeed,0,newVSpeed));
+    }
+
+    /**
+    @brief
+        Set the bats for the ball.
+    @param bats
+        An array (of size 2) of weak pointers, to be set as the new bats.
+    */
+    void JumpEnemy::setFigure(WeakPtr<JumpFigure> newFigure)
+    {
+        figure_ = newFigure;
+    }
+
+    void JumpEnemy::touchFigure()
+    {
+
+    }
+}
Index: code/branches/pickupsFS14/src/modules/jump/JumpEnemy.h
===================================================================
--- code/branches/pickupsFS14/src/modules/jump/JumpEnemy.h	(revision 10050)
+++ code/branches/pickupsFS14/src/modules/jump/JumpEnemy.h	(revision 10050)
@@ -0,0 +1,108 @@
+/*
+ *   ORXONOX - the hottest 3D action shooter ever to exist
+ *                    > www.orxonox.net <
+ *
+ *
+ *   License notice:
+ *
+ *   This program is free software; you can redistribute it and/or
+ *   modify it under the terms of the GNU General Public License
+ *   as published by the Free Software Foundation; either version 2
+ *   of the License, or (at your option) any later version.
+ *
+ *   This program is distributed in the hope that it will be useful,
+ *   but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *   GNU General Public License for more details.
+ *
+ *   You should have received a copy of the GNU General Public License
+ *   along with this program; if not, write to the Free Software
+ *   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
+ *
+ *   Author:
+ *      Fabian 'x3n' Landau
+ *   Co-authors:
+ *      ...
+ *
+ */
+
+/**
+    @file JumpEnemy.h
+    @brief Declaration of the JumpEnemy class.
+    @ingroup Jump
+*/
+
+#ifndef _JumpEnemy_H__
+#define _JumpEnemy_H__
+
+#include "jump/JumpPrereqs.h"
+
+#include "util/Math.h"
+
+#include "worldentities/MovableEntity.h"
+
+
+namespace orxonox
+{
+
+    /**
+    @brief
+        This class manages the ball for @ref orxonox::Jump "Jump".
+
+        It is responsible for both the movement of the ball in the x,z-plane as well as its interaction with the boundaries of the playing field (defined by the @ref orxonox::JumpCenterpoint "JumpCenterpoint") and the @ref orxonox::JumpFigure "JumpFigures". Or more precisely, it makes the ball bounce off then upper and lower delimiters of the playing field, it makes the ball bounce off the bats and also detects when a player scores and takes appropriate measures.
+
+    @author
+        Fabian 'x3n' Landau
+
+    @ingroup Jump
+    */
+    class _JumpExport JumpEnemy : public MovableEntity
+    {
+        public:
+            JumpEnemy(Context* context);
+            virtual ~JumpEnemy();
+
+            virtual void tick(float dt);
+
+            virtual void XMLPort(Element& xmlelement, XMLPort::Mode mode);
+
+            /**
+            @brief Set the dimensions of the playing field.
+            @param width The width of the playing field.
+            @param height The height of the playing field.
+            */
+            void setFieldDimension(float width, float height)
+                { this->fieldWidth_ = width; this->fieldHeight_ = height; }
+            /**
+            @brief Get the dimensions of the playing field.
+            @param dimension A vector with the width as the first and height as the second component.
+            */
+            void setFieldDimension(const Vector2& dimension)
+                { this->setFieldDimension(dimension.x, dimension.y); }
+            /**
+            @brief Get the dimensions of the playing field.
+            @return Returns a vector with the width as the first and height as the second component.
+            */
+            Vector2 getFieldDimension() const
+                { return Vector2(this->fieldWidth_, this->fieldHeight_); }
+
+            virtual void setProperties(float newLeftBoundary, float newRightBoundary, float newLowerBoundary, float newUpperBoundary, float newHSpeed, float newVSpeed);
+
+            void setFigure(WeakPtr<JumpFigure> bats); //!< Set the bats for the ball.
+
+            virtual void touchFigure();
+
+        protected:
+            float fieldWidth_; //!< The width of the playing field.
+            float fieldHeight_; //!< The height of the playing field.
+
+            float leftBoundary_;
+            float rightBoundary_;
+            float lowerBoundary_;
+            float upperBoundary_;
+
+            WeakPtr<JumpFigure> figure_; //!< An array with the two bats.
+    };
+}
+
+#endif /* _JumpEnemy_H__ */
Index: code/branches/pickupsFS14/src/modules/jump/JumpFigure.cc
===================================================================
--- code/branches/pickupsFS14/src/modules/jump/JumpFigure.cc	(revision 10050)
+++ code/branches/pickupsFS14/src/modules/jump/JumpFigure.cc	(revision 10050)
@@ -0,0 +1,255 @@
+/*
+ *   ORXONOX - the hottest 3D action shooter ever to exist
+ *                    > www.orxonox.net <
+ *
+ *
+ *   License notice:
+ *
+ *   This program is free software; you can redistribute it and/or
+ *   modify it under the terms of the GNU General Public License
+ *   as published by the Free Software Foundation; either version 2
+ *   of the License, or (at your option) any later version.
+ *
+ *   This program is distributed in the hope that it will be useful,
+ *   but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *   GNU General Public License for more details.
+ *
+ *   You should have received a copy of the GNU General Public License
+ *   along with this program; if not, write to the Free Software
+ *   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
+ *
+ *   Author:
+ *      Fabian 'x3n' Landau
+ *   Co-authors:
+ *      ...
+ *
+ */
+
+/**
+    @file JumpFigure.cc
+    @brief Implementation of the JumpFigure class.
+*/
+
+#include "JumpFigure.h"
+
+#include "core/CoreIncludes.h"
+#include "core/XMLPort.h"
+
+namespace orxonox
+{
+    RegisterClass(JumpFigure);
+
+    /**
+    @brief
+        Constructor. Registers and initializes the object.
+    */
+    JumpFigure::JumpFigure(Context* context) : ControllableEntity(context)
+    {
+        RegisterObject(JumpFigure);
+
+        this->movement_ = 0;
+        this->bMoveLocal_ = false;
+        this->length_ = 0.25;
+        this->fieldWidth_ = 180;
+        this->bSteadiedPosition_ = false;
+
+        moveUpPressed = false;
+        moveDownPressed = false;
+        moveLeftPressed = false;
+        moveDownPressed = false;
+        firePressed = false;
+        fireSignal = false;
+        timeSinceLastFire = 0.0;
+
+        gravityAcceleration = 8.0;
+        mouseFactor_ = 75.0;
+        maxFireRate = 0.3;
+    }
+
+    /**
+    @brief
+        Method to create a JumpCenterpoint through XML.
+    */
+    void JumpFigure::XMLPort(Element& xmlelement, XMLPort::Mode mode)
+    {
+        SUPER(JumpFigure, XMLPort, xmlelement, mode);
+        XMLPortParam(JumpFigure, "mouseFactor", setMouseFactor, getMouseFactor, xmlelement, mode);
+    }
+
+    /**
+    @brief
+        Is called each tick.
+        Moves the bat.
+    @param dt
+        The time since last tick.
+    */
+    void JumpFigure::tick(float dt)
+    {
+    	SUPER(JumpFigure, tick, dt);
+
+        // If the bat is controlled (but not over the network).
+        if (this->hasLocalController())
+        {
+        	timeSinceLastFire += dt;
+
+            /*if (this->movement_ != 0)
+            {
+                // The absolute value of the movement is restricted to be lesser or equal than the speed of the bat.
+                this->movement_ = clamp(this->movement_, -1.0f, 1.0f) * this->speed_;
+
+                // If moveRightLeft() is used the movement is dependento on wehther it is the right or the left bat, so, it is i.e. dependent on the orientation of the bat.
+                if (this->bMoveLocal_)
+                    this->setVelocity(this->getOrientation() * Vector3(this->movement_, 0, 0));
+                else
+                    this->setVelocity(0, 0, this->movement_);
+
+                this->movement_ = 0;
+                this->bSteadiedPosition_ = false;
+            }
+            // If there is no movement but the position has not been steadied, the velocity is set to zero and the position is reaffirmed.
+            else if (!this->bSteadiedPosition_)
+            {
+                // To ensure network synchronicity
+                this->setVelocity(0, 0, 0);
+                this->setPosition(this->getPosition());
+                this->bSteadiedPosition_ = true;
+            }*/
+
+
+        	Vector3 velocity = getVelocity();
+
+        	velocity.z -= gravityAcceleration;
+
+        	/*if (moveLeftPressed == true)
+        	{
+        		velocity.x = -accelerationFactor;
+        		moveLeftPressed = false;
+        	}
+        	if (moveRightPressed == true)
+        	{
+        		velocity.x = accelerationFactor;
+        		moveRightPressed = false;
+        	}*/
+
+        	velocity.x = -mouseFactor_*horizontalSpeed;
+
+        	if (moveUpPressed == true)
+        	{
+        		velocity.z = 200.0f;
+        		moveUpPressed = false;
+        	}
+        	if (moveDownPressed == true)
+        	{
+        		moveDownPressed = false;
+        	}
+
+        	setVelocity(velocity);
+
+        	if (firePressed && timeSinceLastFire >= maxFireRate)
+        	{
+				firePressed = false;
+				timeSinceLastFire = 0.0;
+				fireSignal = true;
+				//orxout() << "fired signal set" << endl;
+        	}
+        }
+
+        Vector3 position = this->getPosition();
+
+        if (position.x < -fieldWidth_*1.1)
+        {
+        	position.x = fieldWidth_*1.1;
+        }
+        else if (position.x > fieldWidth_*1.1)
+        {
+        	position.x = -fieldWidth_*1.1;
+        }
+
+        this->setPosition(position);
+
+        moveUpPressed = false;
+        moveDownPressed = false;
+        moveLeftPressed = false;
+        moveDownPressed = false;
+        firePressed = false;
+    }
+
+    void JumpFigure::JumpFromPlatform(JumpPlatform* platform)
+    {
+    	Vector3 velocity = getVelocity();
+    	velocity.z = 200.0f;
+    	setVelocity(velocity);
+    }
+
+
+    /**
+    @brief
+        Overloaded the function to steer the bat up and down.
+    @param value
+        A vector whose first component is the inverse direction in which we want to steer the bat.
+    */
+    void JumpFigure::moveFrontBack(const Vector2& value)
+    {
+    	if (value.x > 0)
+    	{
+    		//orxout() << "up pressed" << endl;
+    		moveUpPressed = true;
+    		moveDownPressed = false;
+    	}
+    	else
+    	{
+    		//orxout() << "down pressed" << endl;
+    		moveUpPressed = false;
+    		moveDownPressed = true;
+    	}
+    }
+
+    /**
+    @brief
+        Overloaded the function to steer the bat up and down.
+    @param value
+        A vector whose first component is the direction in which we wnat to steer the bat.
+    */
+    void JumpFigure::moveRightLeft(const Vector2& value)
+    {
+    	if (value.x > 0)
+    	{
+    		//orxout() << "right pressed" << endl;
+    		moveLeftPressed = false;
+    		moveRightPressed = true;
+    	}
+    	else
+    	{
+    		//orxout() << "left pressed" << endl;
+    		moveLeftPressed = true;
+    		moveRightPressed = false;
+    	}
+        /*this->bMoveLocal_ = true;
+        this->movement_ = value.x;*/
+    }
+
+    void JumpFigure::rotateYaw(const Vector2& value)
+    {
+    	horizontalSpeed = value.x;
+
+    }
+
+    void JumpFigure::rotatePitch(const Vector2& value)
+    {
+
+
+    }
+
+    void JumpFigure::rotateRoll(const Vector2& value)
+    {
+
+
+    }
+
+    void JumpFigure::fired(unsigned int firemode)
+    {
+    	orxout() << "fire pressed" << endl;
+    	firePressed = true;
+    }
+}
